unit Z1401;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, StdCtrls, Buttons, ExtCtrls, Menus;

const
  dictName = 'dict.txt';
  delitel: set of char = [' ',',','.',';',':','"','''','(',')',']','[','{','}',#13]; // Co muze delit slova...
type
  TMainForm = class(TForm)
    MainAList: TActionList;
    LoadDict: TAction;
    Translate: TAction;
    InputPanel: TPanel;
    OutputPanel: TPanel;
    InputMemo: TMemo;
    OutputMemo: TMemo;
    OpenInputBtn: TSpeedButton;
    OpenOutputBtn: TSpeedButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    MakeIt: TBitBtn;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Konec1: TMenuItem;
    Uloitvstup1: TMenuItem;
    Uloitvstup2: TMenuItem;
    N1: TMenuItem;
    Slovnk1: TMenuItem;
    Editorslovnku1: TMenuItem;
    procedure LoadDictExecute(Sender: TObject);
    procedure TranslateExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OpenInputBtnClick(Sender: TObject);
    procedure OpenOutputBtnClick(Sender: TObject);
    procedure MakeItClick(Sender: TObject);
    procedure Editorslovnku1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Uloitvstup1Click(Sender: TObject);
  private
    { Private declarations }
    InputFileName, OutputFileName: TFileName;
  public
    function ReadWord(Source: String;var Position: Integer): String;
    function OwnTrim(Source: String): String;
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  Words: TStringList;

implementation

uses Z1402, Z1403;

{$R *.DFM}

function TMainForm.OwnTrim(Source: String): String;
var
 Counter: Integer;
begin
 Result := ''; // Mae mezery, rky a jin "blbosti"
 for Counter := 1 to Length(Source) do
  if Source[Counter] in ['a'..'z','A'..'Z','0'..'9','','','','','','','','','','','','','','','','','','','','','','','','','','','']
  then Result := Result + Source[Counter];
end;

function TMainForm.ReadWord(Source: String;var Position: Integer): String;
var
 Counter: Integer;
begin
 Counter := Position;
 Result := '';
 if Length(Source)>0 then
 while (not (Source[Counter] in delitel)) and (Counter<Length(Source)) do
 begin
  Result := Result + Source[Counter];
  Inc(Counter);
 end;
 Result := Result + Source[Counter];
 Inc(Counter);
 Position := Counter;
end;

procedure TMainForm.LoadDictExecute(Sender: TObject);
var
 DictFile: TextFile;
 Temp: String;
 InputStr: String;
begin
{ LoadingForm.Visible := True;
 LoadingForm.Status.Caption := 'Natn slovnku...';}
 if not FileExists(dictName) then
 begin
  ShowMessage('Slovnik neexistuje...');
  Application.Terminate;
 end;
 Words := TStringList.Create;
 AssignFile(DictFile,dictName);
 Reset(DictFile);
{ LoadingForm.RePaint;}
 while not eof(DictFile) do
 begin
  ReadLn(DictFile,Temp);
  If Pos('/',Temp) > 0 then Delete(Temp,Pos('/',Temp),Length(Temp));
  Words.Add(UpperCase(Temp));
 end;
{ LoadingForm.Visible := False;}
 {Ladn}

 {/Ladeni}
end;

procedure TMainForm.TranslateExecute(Sender: TObject);
var
 Input, Output: TextFile;
 Temp: String;
 Position: Integer;
 InputStr: String;
begin
 Application.CreateForm(TLoadingForm, LoadingForm); // Vytvome oknko, kter nm signalizuje bh programu...
 LoadingForm.Visible := True;
 LoadingForm.RePaint;
 LoadingForm.Status.Caption := 'Probh peklad...';
 if ExtractFilePath(InputFileName)='' then InputFileName := GetCurrentDir + '\' + InputFileName;
 // Co, kdy neni zadan cesta k souboru
 if not FileExists(InputFileName) then // Existuje vbec
 begin
  ShowMessage(Format('Vstupn soubor %s nenalezen...',[InputFileName]));
  Application.Terminate;
 end;
 AssignFile(Input,InputFileName);
 AssignFile(Output,OutputFileName);
 Reset(Input);
 ReWrite(Output);
 repeat
 ReadLn(Input,InputStr);                 //Postupn teme dku po dce...
 Position := 1;
 while Position < Length(InputStr) do
 begin
  Temp := ReadWord(InputStr,Position);
  if (Words.IndexOf(OwnTrim(UpperCase(Temp)))<0) and (OwnTrim(Temp) <> '')
  then Temp := '#' + Temp;
  Write(Output,Temp);
 end;
 WriteLn(Output);
 until Eof(Input);
 CloseFile(Input);
 CloseFile(Output);
 LoadingForm.Status.Caption := 'Dokoneno...';
 LoadingForm.Visible := False;
 LoadingForm.Free;  // Hotovka, uklidme po sob...
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 Words.Free; // Jarn klid...
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 LoadDict.Execute; // Nateme slovnk do pamti...
 if ParamCount = 2 then // Jsou zadny parametry
 begin
  InputFileName := ParamStr(1);
  OutputFileName := ParamStr(2);
  Translate.Execute; // Spustme peklad
  ShowMessage('Peklad dokonen');
  Application.Terminate;
 end;
end;

procedure TMainForm.OpenInputBtnClick(Sender: TObject);
begin
 if OpenDialog.Execute then
 begin
  InputMemo.Lines.LoadFromFile(OpenDialog.FileName);
  InputFileName := OpenDialog.FileName;
 end;
end;

procedure TMainForm.OpenOutputBtnClick(Sender: TObject);
begin
 If SaveDialog.Execute then
 OutputMemo.Lines.SaveToFile(SaveDialog.FileName);
end;

procedure TMainForm.MakeItClick(Sender: TObject);
begin
 if (InputFileName = '') or (InputMemo.Modified) then
 begin
 if MessageDlg('Bude nutn soubor uloit. Pejete si tak udlat',mtConfirmation,[mbOK,mbCancel],0) = mrOK then
 begin
  if SaveDialog.Execute then
  begin
   InputMemo.Lines.SaveToFile(SaveDialog.FileName);
   InputFileName := SaveDialog.FileName;
   OutputFileName := 'TEMP.~00';  // Vytvome "swapk"
   Translate.Execute; // Spustme peklad
   OutputMemo.Lines.LoadFromFile('TEMP.~00'); // Nateme do mema
   DeleteFile('TEMP.~00'); // a opt uklidme...
  end;
 end;
 end else
 begin
  OutputFileName := 'TEMP.~00';  // Vytvome "swapk"
  Translate.Execute; // Spustme peklad
  OutputMemo.Lines.LoadFromFile('TEMP.~00'); // Nateme do mema
  DeleteFile('TEMP.~00'); // a opt uklidme...
 end;
end;

procedure TMainForm.Editorslovnku1Click(Sender: TObject);
begin
 DicEdit.ShowModal;
end;

procedure TMainForm.Konec1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TMainForm.Uloitvstup1Click(Sender: TObject);
begin
 if SaveDialog.Execute then
 OutputMemo.Lines.SaveToFile(SaveDialog.FileName);
end;

end.
